#include "types.h"
#include "histo.h"
#include "arith.h"


Arith::Arith(InputBuf *iBuf, OutputBuf *oBuf, int bits)
{
    init(iBuf, oBuf, bits);
}


void Arith::init(InputBuf *iBuf, OutputBuf *oBuf, int bits)
{
    Arith::iBuf = iBuf;
    Arith::oBuf = oBuf;
    Arith::bits = bits;
    half = 1 << (bits - 1);
    qtr = half >> 1;
}


void Arith::startEncoding()
{
    L = 0;
    R = half;
    followBits = 0;
}


void Arith::finishEncoding()
{
    word mask = half;
    while (mask)
    {
        putBit((L & mask) ? 1 : 0);
        mask >>= 1;
    }
}


void Arith::startDecoding()
{
    L = 0;
    word mask = half;
    while (mask)
    {
        if (iBuf->getBit())
        {
            L |= mask;
        }
        mask >>= 1;
    }
    R = half;
}


void Arith::encodeBlock(Histogram *H)
{
    while (iBuf->nCharsLeft())
    {
        encodeSymbol(iBuf->getChar(), H);
    }
}


void Arith::decodeBlock(Histogram *H) {
    while (iBuf->nCharsLeft() && oBuf->nCharsLeft())
    {
        oBuf->putChar(decodeSymbol(H));
    }
}
