#include <stdlib.h>
#include "crc32.h"


#define CRC32_POLYNOMIAL 0xedb88320


CRC32::CRC32()
{
  init();
  buildTable();
}


CRC32::~CRC32()
{
    if (table)
    {
        free(table);
    }
}


void CRC32::init()
{
  crc = 0;
}


void CRC32::buildTable()
{
    word value;
    table = (word*)malloc(256 * sizeof(word));
    for (int i = 0; i < 256; i++)
    {
        value = i;
        for (int j = 8; j > 0; j--)
        {
            if (value & 0x01)
            {
                value = (value >> 1) ^ CRC32_POLYNOMIAL;
            }
            else
            {
                value >>= 1;
            }
        }
        table[i] = value;
    }
}
