#ifndef CRC32_H
#define CRC32_H

#include "types.h"

class CRC32
{
public:
                 CRC32();
                ~CRC32();
    void         init();
    inline word  CRC() { return crc; };
    inline void  addByte(int b);
    inline void  addString(byte *p, word n);
protected:
    void         buildTable();
    word         crc;
    word        *table;
};

void CRC32::addByte(int b)
{
    word t1, t2;
    t1 = (crc >> 8) & 0xffffff;
    t2 = table[((int) crc ^ b) & 0xff];
    crc = t1 ^ t2;
}

void CRC32::addString(byte *p, word n)
{
    word t1, t2;
    while (n--)
    {
        t1 = (crc >> 8) & 0xffffff;
        t2 = table[((int) crc ^ *p++) & 0xff];
        crc = t1 ^ t2;
    }
}

#endif
