#include "types.h"
#include "histo.h"


Histogram::Histogram(int nSymbols, int incVal, int incLimit)
{
    initialized = 0;
    init(nSymbols, incVal, incLimit);
    initialized = 1;
}


Histogram::~Histogram()
{
    delete [] freq;
}


void
Histogram::init(int nSymbols, int incVal, int incLimit)
{
    Histogram::nSymbols = nSymbols;
    Histogram::incVal = incVal;
    Histogram::incLimit = incLimit;
    if (initialized)
    {
        delete freq;
    }
    freq = new word[nSymbols];
    if (incVal)
    {
        totFreq = nSymbols * incVal;
        for (int i = 0; i < nSymbols; i++)
        {
            freq[i] = incVal;
        }
    }
    else
    {
        totFreq = nSymbols;
        for (int i = 0; i < nSymbols; i++)
        {
            freq[i] = 1;
        }
    }
}
