#ifndef HISTO_H
#define HISTO_H

#include "types.h"

class Histogram
{
public:
                 Histogram(int nSymbols, int incVal, int incLimit);
                ~Histogram();
    void         init(int nSymbols, int incVal, int incLimit);
    inline void  update(int symbol);
    inline word  getFreq(int symbol) { return freq[symbol]; };
    inline word  getTotFreq() { return totFreq; };
protected:
    int          initialized;
    int          nSymbols;
    word         incVal, incLimit;
    word         totFreq;
    word        *freq;
};


void Histogram::update(int symbol)
{
    freq[symbol] += incVal;
    totFreq += incVal;
    if (totFreq > incLimit)
    {
        totFreq = 0;
        for (int i = 0; i < nSymbols; i++)
        {
            freq[i] = (freq[i] + 1) >> 1;
            totFreq += freq[i];
        }
    }
}

#endif
